package com.kusalic.zavrsni;

import java.awt.Color;
import java.awt.Graphics;
import java.util.ArrayList;

import javax.swing.JPanel;

/**
 * Klasa ostvaruje graficki prikaz rjesenja problema krojenja
 * @author Domagoj
 */
public class Prikaz extends JPanel {
	private static final long serialVersionUID = 1L;
	Krojenje tko;
	Prikaz(Krojenje tko) {
		this.tko=tko;
	}
    void postavi(Krojenje x) {
    	tko=x; 
    	repaint(); 
    }
	public void paintComponent(Graphics g) {
		super.paintComponent(g);
		//setSize(getMaximumSize());
		int visina=getHeight()-2, sirina=getWidth()-2;
		g.setColor(Color.blue); // ovo crta (koristi g)
		setBackground(Color.WHITE);
		ZapisProblema problem=tko.getProblem();
		int n=problem.oblici.size();
		ArrayList<Double> Tx=problem.Tx;
		ArrayList<Double> Ty=problem.Ty;

		double maxX=Integer.MIN_VALUE,minX=Integer.MAX_VALUE,
		       maxY=Integer.MIN_VALUE,minY=Integer.MAX_VALUE;
		double max2X,max2Y;
		for (int i=0;i<n;i++) {
			double Posx=tko.getX()[i];
			double Posy=tko.getY()[i];
			double Poskut=tko.getKut()[i];
			double tx,ty,x,y;
			ArrayList<Integer> ai=problem.oblici.get(i);
			for (Integer j: ai) {
				tx = Tx.get(j.intValue());
				ty = Ty.get(j.intValue());
				x=tx*Math.cos(Poskut) - ty*Math.sin(Poskut)  + Posx;
				y=tx*Math.sin(Poskut) + ty*Math.cos(Poskut)  + Posy;
				maxX=Math.max(maxX,x);
				maxY=Math.max(maxY,y);
				minX=Math.min(minX,x);
				minY=Math.min(minY,y);
			}
		}
		max2X=maxX;
		max2Y=maxY;
		int ispredX=0,ispredY=0;
		if ((maxX-minX) / (maxY-minY) < (double)visina / sirina ) {
			ispredX = (int) ((minX+ ((maxY-minY)* visina / sirina) - maxX)/2);
			maxX = minX+ ((maxY-minY)* visina / sirina); 
		}
		if ((maxY-minY)/(maxX-minX) < (double)sirina/ visina ) {
			ispredY = (int) ((minY+ ((maxX-minX)* sirina / visina) - maxY)/2);
			maxY = minY+ ((maxX-minX)* sirina / visina);
		}
		
		{ // okolnji pravokutnik
			g.setColor(Color.red); 
			double Lx,Ly,x,y;
			Lx=minX; Ly=minY; x=minX; y=max2Y;
			g.drawLine(1+ispredY*sirina/(int)(maxY-minY)+(int)((Ly -minY)*sirina/(maxY-minY)  +0.5), 1+ispredX*visina/(int)(maxX-minX)+(int)((Lx -minX)*visina/(maxX-minX)  +0.5),
					1+ispredY*sirina/(int)(maxY-minY)+(int)(( y -minY)*sirina/(maxY-minY)  +0.5), 1+ispredX*visina/(int)(maxX-minX)+(int)(( x -minX)*visina/(maxX-minX)  +0.5)); // crta (y1,x1,y2,x2);
			Lx=minX; Ly=minY; x=max2X; y=minY;
			g.drawLine(1+ispredY*sirina/(int)(maxY-minY)+(int)((Ly -minY)*sirina/(maxY-minY)  +0.5), 1+ispredX*visina/(int)(maxX-minX)+(int)((Lx -minX)*visina/(maxX-minX)  +0.5),
					1+ispredY*sirina/(int)(maxY-minY)+(int)(( y -minY)*sirina/(maxY-minY)  +0.5), 1+ispredX*visina/(int)(maxX-minX)+(int)(( x -minX)*visina/(maxX-minX)  +0.5)); // crta (y1,x1,y2,x2);
			Lx=max2X; Ly=max2Y; x=minX; y=max2Y;
			g.drawLine(1+ispredY*sirina/(int)(maxY-minY)+(int)((Ly -minY)*sirina/(maxY-minY)  +0.5), 1+ispredX*visina/(int)(maxX-minX)+(int)((Lx -minX)*visina/(maxX-minX)  +0.5),
					1+ispredY*sirina/(int)(maxY-minY)+(int)(( y -minY)*sirina/(maxY-minY)  +0.5), 1+ispredX*visina/(int)(maxX-minX)+(int)(( x -minX)*visina/(maxX-minX)  +0.5)); // crta (y1,x1,y2,x2);
			Lx=max2X; Ly=max2Y; x=max2X; y=minY;
			g.drawLine(1+ispredY*sirina/(int)(maxY-minY)+(int)((Ly -minY)*sirina/(maxY-minY)  +0.5), 1+ispredX*visina/(int)(maxX-minX)+(int)((Lx -minX)*visina/(maxX-minX)  +0.5),
					1+ispredY*sirina/(int)(maxY-minY)+(int)(( y -minY)*sirina/(maxY-minY)  +0.5), 1+ispredX*visina/(int)(maxX-minX)+(int)(( x -minX)*visina/(maxX-minX)  +0.5)); // crta (y1,x1,y2,x2);
			g.setColor(Color.blue); 
		}
		for (int i=0;i<n;i++) {
			double Posx=tko.getX()[i];
			double Posy=tko.getY()[i];
			double Poskut=tko.getKut()[i];
			double Lx,Ly,x,y,tx,ty;
			ArrayList<Integer> ai=problem.oblici.get(i);
			tx = Tx.get(ai.get(ai.size()-1).intValue());
			ty = Ty.get(ai.get(ai.size()-1).intValue());
			Lx=tx*Math.cos(Poskut) - ty*Math.sin(Poskut) + Posx;
			Ly=tx*Math.sin(Poskut) + ty*Math.cos(Poskut) + Posy;

			for (Integer j: ai) {
				tx = Tx.get(j.intValue());
				ty = Ty.get(j.intValue());
				x=tx*Math.cos(Poskut) - ty*Math.sin(Poskut) + Posx;
				y=tx*Math.sin(Poskut) + ty*Math.cos(Poskut) + Posy;
				
				g.drawLine(1+ispredY*sirina/(int)(maxY-minY)+(int)((Ly -minY)*sirina/(maxY-minY)  +0.5), 1+ispredX*visina/(int)(maxX-minX)+(int)((Lx -minX)*visina/(maxX-minX)  +0.5),
						   1+ispredY*sirina/(int)(maxY-minY)+(int)(( y -minY)*sirina/(maxY-minY)  +0.5), 1+ispredX*visina/(int)(maxX-minX)+(int)(( x -minX)*visina/(maxX-minX)  +0.5)); // crta (y1,x1,y2,x2);
				Lx = x;
				Ly = y;
			}
		}
	}
}
