package com.kusalic.zavrsni;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.StringTokenizer;

/**
 * Ostvaruje obrazac jedinstvenog objekta za potrebu stvaranja zapisa problema
 * @author Domagoj
 *
 */
public class ZapisProblema {

	private static boolean stvoren = false;
	private static ZapisProblema objekt=null;
	
	public ArrayList<Double> Tx, Ty;
	public ArrayList<ArrayList<Integer>> oblici;
	
	private ZapisProblema() {
	}
	
	public static void stvori(File file) throws IOException {
		BufferedReader in = new BufferedReader(new FileReader(file));
		objekt = new ZapisProblema();
		objekt.Tx = new ArrayList<Double>();
		objekt.Ty = new ArrayList<Double>();
		objekt.oblici = new ArrayList<ArrayList<Integer>>();
		
		String s;
		while ((s = in.readLine()) !=null) {
			if (s.length()==0 || s.charAt(0)==' ') continue;
			StringTokenizer st = new StringTokenizer(s," ");
			String tip=st.nextToken().trim();
			if (tip.equals("v")) {
				objekt.Tx.add(new Double(st.nextToken().trim()));
				objekt.Ty.add(new Double(st.nextToken().trim()));
			} else if (tip.equals("f")) {
				ArrayList<Integer> oblik = new ArrayList<Integer>(); 
				while (st.hasMoreTokens()) {
					oblik.add(new Integer(Integer.parseInt(st.nextToken().trim())-1));
				}
				objekt.oblici.add(oblik);
			} else if (tip.equals("#"))
				;
			else
				System.err.println("Datoteka nije dobro formirana!");
		}	
	    in.close();
		
		stvoren=true;
	}
	
	public static ZapisProblema dajJedinku() {
		if (!stvoren) return null;
		return objekt;
	}
	
//	public static void main(String[] args) {
//		try {
//			new GA().init(new File("objekti.in"));
//		} catch (IOException e) {
//			System.err.println("Nema Filea!");
//			e.printStackTrace();
//		}
//		System.out.println(ZapisProblema.dajJedinku().Tx);
//		System.out.println(ZapisProblema.dajJedinku().Ty);
//		System.out.println(ZapisProblema.dajJedinku().oblici);
//	}

}
